'================================================================================
'{Titulo}
'================================================================================
 'GetDriveType
 'Angel Berbel, febrero 2012
'================================================================================
'{API Declaration}
'================================================================================
Declare GetDriveType  As "GetDriveTypeA" of "kernel32" 
  nDrive As String
  result As Long
End Declare
'================================================================================
'{RESOURCES}
'================================================================================
Resource bmp1 As "GetDriveType\DiscoFlexible.bmp"
Resource bmp2 As "GetDriveType\DiscoDuro.bmp"
Resource bmp3 As "GetDriveType\DiscoExtraible.bmp"
Resource bmp4 As "GetDriveType\Discooptico.bmp"
'================================================================================
'{GUI}
'================================================================================
Dim trvBitmap1 As Bitmap
Dim trvBitmap2 As Bitmap
Dim trvBitmap3 As Bitmap
Dim trvBitmap4 As Bitmap
Object frmForm As Form
  Caption="GetDriveType API call"
  Height=480
  Width=640
  Center
  'Otros objetos
   Object trvTreeview As Treeview
     Left=10
     Top=10
     Width=200
     Height=300
    'Sorted=True
'    AddItem("Item1",-1)  'raiz si es -1
'    AddItem("Item2",-1)
'    AddItem("Item3",-1)
    'AddItem("SubItem1",0)   'hijo
    'AddItem("SubItem1",2)
    'AddItem("SubItem1",4)
    'color=&HFF00FF
    'Ondblclick=trvTreeview_ondblClick
  End Object
  'Fin otros objetos
  Onshow=frmForm_OnShow
  'OnClose=frmForm_OnClose
End Object
frmForm.showmodal
'================================================================================
'{SUBS and FUNCS}
'================================================================================
Sub frmForm_OnShow
  Dim i As Integer,primerAsc As Integer, ultimoAsc As Integer
  Dim LetraDrive As String
  primerAsc=65
  ultimoAsc=primerAsc+25
    For i=primerAsc To ultimoAsc Then
      GetDriveType.nDrive=Chr$(i)+":\"
      GetDriveType.Execute
      If GetDriveType.result<>1 Then
        letradrive=Chr$(i)+":"
        trvTreeview.additem(letradrive,-1)
        Call EstableceIcon(trvTreeview.ItemCount-1, LetraDrive)
         
      End If
    Next I
End Sub
'********************************************************************************
Sub EstableceIcon(Indice As Long, ruta As String)
  Dim nombreIndice As String
  trvBitmap1.Loadfromresource(bmp1)
  trvBitmap2.Loadfromresource(bmp2)
  trvBitmap3.Loadfromresource(bmp3)
  trvBitmap4.Loadfromresource(bmp4)
 
  trvTreeview. Addbmp(0,trvBitmap1)
  trvTreeview.AddBMP(1,trvBitmap2)
  trvTreeview.AddBMP(2,trvBitmap3)
  trvTreeview.AddBMP(3,trvBitmap4)

  GetDriveType.nDrive=ruta
  GetDriveType.Execute
    If GetDriveType.result<>1 Then
      Select Case GetDriveType.result
        Case 2
          If ruta="A:" Then 
            trvTreeview.BMPindex(indice)=0
            nombreIndice=trvTreeview.caption(indice)
            trvTreeview.caption(indice)="Floppy disk " +"("+nombreIndice+")"
          Else 
            trvTreeview.BMPindex(indice)=2
            nombreIndice=trvTreeview.caption(indice)
            trvTreeview.caption(indice)="Removable disk " +"("+nombreIndice+")"
          End If
        Case 3
            trvTreeview.BMPindex(indice)=1
            nombreIndice=trvTreeview.caption(indice)
            trvTreeview.caption(indice)="Hard Disk " +"("+nombreIndice+")"

        Case 4
           nombreIndice=trvTreeview.caption(indice)
            trvTreeview.caption(indice)="Remote disk " +"("+nombreIndice+")"
        Case 5
          trvTreeview.BMPindex(indice)=3
          nombreIndice=trvTreeview.caption(indice)
          trvTreeview.caption(indice)="Optical disk " +"("+nombreIndice+")"
        Case 6
          nombreIndice=trvTreeview.caption(indice)
            trvTreeview.caption(indice)="RAM disk " +"("+nombreIndice+")"
     End Select
  End If
End Sub